/* clistA(miga)   24.07.92

   Programmautor: Edgar G. Meyzis

   Portables Programm in ANSI C, um Funktionskoepfe
   hervorgehoben auszudrucken, wie mit den Konstanten
   MarkierungOn bzw. MarkierungOff bestimmt.

   Portabilitaetseinschraenkungen bestehen nur fuer die
   Funktion SetPrinter() und neben den genannten Konstanten
   noch fuer DruckerName.

   Mit DICE:

   Uebersetzen: dcc CLista.c -c -o t:Clista.o

   Binden: dlink dlib:c.o t:CLista.o dlib:c.lib+
           dlib:amigas20.lib dlib:auto.lib dlib:x.o -o CLIST
*/
#include  <ctype.h>
#include  <stdio.h>
#include <string.h>
/*
#define DEBUG  leitet Ausgaben um
*/
/*
<<<<<<<<<<<<<<<<<<<<<<<  KONSTANTEN >>>>>>>>>>>>>>>>>>>>>>>>
*/
/* Format und Layout ++++++++++++++++++++++++++++++++++++ */

#define MaxZeilen    58                     /* pro Seite  */
#define ZeilenBreite 85
#define PosSeitenNr  ZeilenBreite - 7     /* in Kopfzeile */

/* Steuerzeichen und einzelne ASCII-Zeichen +++++++++++++ */

#define ZeileHervorheben 0X7 /* steuert ZeichenAusgeben() */
#define FormFeed        "\f"
#define ZeilEnde         0XA
#define StrEnde          0X0
#define LeerZeich       0X20

/* Zeichenketten ++++++++++++++++++++++++++++++++++++++++ */

#define kurz   10
#define mitl   40
#define lang  100

typedef char  STRkurz[kurz];
typedef char  STRmitl[mitl];
typedef char  STRlang[lang];
typedef enum {FALSE, TRUE} BOOL;

/* Implementationsabhaengige Konstanten +++++++++++++++++ */

#ifndef DEBUG
   char    DruckerName[]   = "PRT:";
#else
   char    DruckerName[]   = "ram:tmp.tmp";
#endif

char    MarkierungOn[]  = "\33[1m";     /* ESC + Boldface */
char    MarkierungOff[] = "\33[22m";/* ESC + Boldface off */

/* <<<<<<<<<<<<<<<<< Funktionsprototypen >>>>>>>>>>>>>>>  */


/* jede Seite hat einen Kopf ++++++++++++++++++++++++++++ */

void  MakeSpecialString(char, int, STRlang);
void  TopZeilenErstellen ();
void  KopfZeilenAusgeben ();

/* Ein- u. Ausgaberoutinen ++++++++++++++++++++++++++++++ */

void  ZeichenLesen();                 /* vom Input Stream */
void  ZeichenAusgeben(char);           /* in Sammelzeile  */
void  ZeileDrucken(STRlang);         /* an Output Stream */
void  SeitenVorschub(); /* Zaehl setzen, Kopfzeil. ausgeb.*/
void  PlatzGarantieren();   /* Funkt. moegl. auf 1 Seite  */
void  GetDatum(STRlang datum);
void  LeerZeichenKopieren();


void  SetPrinter();             /* Drucker initialisieren */
void  DruckHervorheben(char*);         /* Funktionskoepfe */

void  FunktionsKopfAusgeben();
void  WortKopieren();            /* Wortanf.  'A'-'z', '_'*/
void  WortBearbeiten();

/* Kommentare und Klammern ++++++++++++++++++++++++++++++ */

void  KommentarKopieren();
void  RestlZeileKopieren();             /* nach # oder // */
void  KommentarBearbeiten();
void  KlammerKopieren(char);/* Arg: Terminator '}' o. ')' */

/* Dateien handhaben u. Ablauf steuern ++++++++++++++++++ */

void  DateiBearbeiten();
void  Drucken();

/*
<<<<<<<<<<<<<<<<<<<< globale Variablen >>>>>>>>>>>>>>>>>>
*/
/* fuer Ein- und Ausgaberoutinen ++++++++++++++++++++++++ */

char    aktZeich,          /* von ZeichenLesen() gespeist */
	nextZeich;

/* Dateimanagement ++++++++++++++++++++++++++++++++++++++ */

FILE*   inFile;           /* Input Datei  */
FILE*   drucker;          /* Druckausgabe */

/* Kopfzeile und Formatsteuerung ++++++++++++++++++++++++ */

STRlang dateiName,
	kopfZeile,    /* Datei: <Name> Datum Zeit   Seite */
	trennLinie;   /* -------------------------------- */
short   seitenZaehler     = 1;  /* fortlaufender Zaehler  */
short   zeilenZaehler     = 0;             /* seitenweise */

BOOL    dateiSchreiben    = TRUE;/* waehrend Platzanalyse */
short   zeilenBedarf      = 0;
BOOL    blockEndeErreicht = FALSE;     /* beendet Analyse */


void  SetPrinter()   /*SP 08.05.92 Drucker initialisieren */
{
  static char Gothic[] = "\33c\33[10s\33[2w";
		      /*    ^   ^    ^
			    |   |     Elite (HP: Gothic)
			    |    li. Rand
			     Reset
		     */
  fputs(Gothic, drucker);
  }

void GetDatum(STRlang datum)                /*GD 08.05.92 */
{
  STRmitl date;                 /* ANSI-gerecht Datum und */
  char    *monat,          /* Uhrzeit der auszudruckenden */
	  *tag,                        /* Datei ermitteln */
	  *jahr;

  strcpy(date, __DATE__);
  monat = strtok(date, " ");  /* um Reihenfolge Monat/Tag */
  tag   = strtok(NULL, " ");               /* zu wechseln */
  jahr  = strtok(NULL, " ");

  switch (*monat)     /* engl. Schreibweisen eindeutschen */
    {
     case 'M' : if (monat[2] == 'r')
		  monat[1] = '';                /* Maerz */
		else
		  monat[2] = 'i';                  /* Mai */
		break;
     case 'O' : monat[1] = 'k';                    /* Okt */
		break;
     case 'D' : monat[2] = 'z';                    /* Dez */
    }
  sprintf(datum, "%s.%s.%s", tag, monat, jahr);
  strcat(datum, " ");
  strcat(datum, __TIME__);
}

/* "times" Positionen einer Ausgabe mit "ch" fuellen */

void MakeSpecialString(char ch, int times, STRlang str)
{
  for (int zaehler = 0; zaehler < times; zaehler++)
    str[zaehler] = ch;
  str[times] = StrEnde;
}

/* die ersten beiden Zeilen jeder Seite erstellen */

void TopZeilenErstellen()                   /*KZ 03.10.92 */
 {
  STRlang kette;

  GetDatum(kette);
  strcat(dateiName, "  ");
  strcat(dateiName, kette);

  strcpy(kopfZeile, "DATEI: ");    /* 03.10.92 cat in cpy */
  strcat(kopfZeile, dateiName);

  MakeSpecialString(LeerZeich,
		    PosSeitenNr - strlen(kopfZeile), kette);
  strcat(kopfZeile, kette);
  MakeSpecialString('-', ZeilenBreite, trennLinie);
 }

void KopfZeilenAusgeben()                  /*KZA 23.02.92 */
{
  STRkurz seitenNummer;

  kopfZeile[PosSeitenNr] = StrEnde; /* Seit. Nr abschneid */
  sprintf(seitenNummer, "- %d -", seitenZaehler);
  strcat(kopfZeile, seitenNummer);
  ZeileDrucken(kopfZeile);
  ZeileDrucken(trennLinie);
}

void DruckHervorheben(char* attribut)       /*DH 12.07.92 */
 {
  for (char index = 0; index < strlen(attribut); index++)
    ZeichenAusgeben(attribut[index]);
 }

void ZeichenLesen()        /*ZL 07.02.92 vom Input-Stream */
{
  aktZeich  = nextZeich;               /* zu verarbeiten  */
  nextZeich = fgetc(inFile);   /* ein Zeichen Vorausschau */
}

void SeitenVorschub()                      /*SV 14.02.93  */
{
  fputs(FormFeed, drucker);
  seitenZaehler ++;
  zeilenZaehler = 0;
  KopfZeilenAusgeben();
}

/* ggf neue Seite beginnen, wenn Funktion mehr Platz benoe-
   tigt als auf aktueller Seite verfuegbar
*/
void PlatzGarantieren()                    /* PG 26.02.92 */
{
  long    filePos;
  char    aktZeichSave,
	  nextZeichSave;

  filePos = ftell(inFile);    /* Stand Dateizeiger merken */
  aktZeichSave = aktZeich;       /* vorbergehend sichern */
  nextZeichSave = nextZeich;

  dateiSchreiben = FALSE;        /* keine  Ausgaben bitte */
  blockEndeErreicht = FALSE;      /* steuert Platzanalyse */
  zeilenBedarf = 1;
  while ((aktZeich != ';') && (!blockEndeErreicht)
			   && (!feof(inFile)))
    {                         /* Zeilenumbrueche zaehlen, */
     DateiBearbeiten();       /* bis zum Ende eine Protyps*/
    }                         /* o. eines Funktionsblocks */
  fseek(inFile, filePos, SEEK_SET);   /* auf gemerkte Pos */
  aktZeich = aktZeichSave;
  nextZeich = nextZeichSave;
  dateiSchreiben = TRUE;           /* es kann weitergehen */
  if ((zeilenZaehler + zeilenBedarf) > MaxZeilen)
    SeitenVorschub();
}

void ZeileDrucken(STRlang zeile)           /*ZA 24.02.92 */
{
  fputs(zeile, drucker);
  putc(ZeilEnde, drucker);               /* Zeilenwechsel */
  zeilenZaehler ++;
  if (zeilenZaehler > MaxZeilen)
    SeitenVorschub();
}

void ZeichenAusgeben(char druckZeich)       /*ZA 12.07.92 */
{
  static STRlang  zeile;/* sammelt f. zeilenweise Ausgabe */
  static int      index= 0;       /* f. Zugriff auf Zeile */
  STRlang         tmpZeile;

  if (dateiSchreiben)
    {if (druckZeich == ZeileHervorheben) /* Zeile m. Funk-*/
        {zeile[index] = StrEnde;         /* tionsname ist */
         strcpy(tmpZeile, zeile);        /* hervorzuheben */
         strcpy(zeile, MarkierungOn);   /* an den Anfang  */
         strcat(zeile, tmpZeile);     /* der Zeile setzen */
         index= strlen(zeile);
         return;
        }

      if (druckZeich != ZeilEnde)
        zeile[index ++] = druckZeich;/* in zeile aufnehm. */
      else
        {zeile[index] = StrEnde;    /* Zeile abschliessen */
         ZeileDrucken(zeile);
         index = 0;
        }
    }
  else            /* Platzanalyse f. eine Funktion laeuft */
    if (druckZeich == ZeilEnde)  /* nur benoetigte Zeilen */
      zeilenBedarf ++;                        /* zaehlen  */
}

void LeerzeichenKopieren()                 /*LZ 24.02.92  */
{
  while ((nextZeich == ' ') && (!feof(inFile)))
    {ZeichenLesen();
     ZeichenAusgeben(' ');
    }
}


void WortKopieren()                         /*WK 15.07.92 */
{
  do
    {ZeichenAusgeben(aktZeich);
     ZeichenLesen();
    }
  while (((nextZeich == '_') || isalpha(nextZeich)
			     || isdigit(nextZeich))
			     && (!feof(inFile)));
  ZeichenAusgeben(aktZeich);
 }


void  FunktionsKopfAusgeben()
{                                           /*FK 15.07.92 */
  /* ggf. Platz fuer Funktion auf einer Seite schaffen */

  PlatzGarantieren();              /* bei Bedarf FormFeed */
  ZeichenAusgeben(ZeileHervorheben);
  ZeichenLesen();                  /* '(' vom Input-Strom */
  KlammerKopieren(')');

  DruckHervorheben(MarkierungOff);
}


void  WortBearbeiten()                     /*WB 15.07.92  */
{
  WortKopieren();

  if (nextZeich == ' ')
    LeerzeichenKopieren();
  if (nextZeich == '(')          /* Funktionsname erkannt */
    FunktionsKopfAusgeben();
}

/* Kommentar vollstaendig ausgeben, aktZeich dann auf '/' */

void KommentarKopieren()                   /*KA 12.07.92  */
{
  do
    {ZeichenAusgeben(aktZeich);
     ZeichenLesen();
    }
   while ((!((aktZeich == '*') && (nextZeich == '/')))
			       && (!feof(inFile)));
   ZeichenAusgeben(aktZeich);  /* '*' */
   ZeichenLesen();
   ZeichenAusgeben(aktZeich);         /* aktZeich ist '/' */
}

void RestlZeileKopieren()                   /*RZ 08.02.92 */
{
  while ((aktZeich != ZeilEnde) && (!feof(inFile)))
    {ZeichenAusgeben(aktZeich);
     ZeichenLesen();
    }
    ZeichenAusgeben(aktZeich);
}

void KommentarBearbeiten()                 /*KB 09.02.92  */
{
  switch (nextZeich)
    {case '/' : RestlZeileKopieren();
		break;
     case '*' : KommentarKopieren();
		break;
     default  : ZeichenAusgeben(aktZeich);
    }
}

void  KlammerKopieren(char terminator)      /*KA 15.02.92 */
{
  int  offeneKlammern = 1;           /* erste in aktZeich */
  char klammerTyp;

  int inHochKomma = FALSE;
  int inAnfuehrZeich = FALSE;

  if (terminator == ')')            /* Art der Klammer ?  */
    klammerTyp = '(';
  else
    {klammerTyp = '{';
     blockEndeErreicht = FALSE;
    }
  ZeichenAusgeben(aktZeich);
  while ((offeneKlammern != 0) && (!feof(inFile)))
    {ZeichenLesen();
     switch(aktZeich)
       {
	case '/': KommentarBearbeiten();/*  Klamm zaehlen */
		  continue;       /* aktZeich ist ausgegeb*/
	case '"': if ((!inAnfuehrZeich) && (!inHochKomma))
		    inAnfuehrZeich = TRUE;
		  else
		    if (inAnfuehrZeich)
		      inAnfuehrZeich = FALSE;
		  break;
	case 39 : if ((!inHochKomma) && (!inAnfuehrZeich))
	/* ' */	    inHochKomma = TRUE;
		  else
		    if (inHochKomma)
		      inHochKomma = FALSE;
       }
     ZeichenAusgeben(aktZeich);
     if ((!inHochKomma) && (!inAnfuehrZeich))
       {if (aktZeich == terminator)
	  offeneKlammern --;
	else
	  if (aktZeich == klammerTyp)
	    offeneKlammern ++;
       }
    } /* while */
  if (klammerTyp ==  '{')
    blockEndeErreicht = TRUE;
}

void DateiBearbeiten()                      /*DB 24.02.92 */
{
   ZeichenLesen();
   switch (aktZeich)
     {case '(' : KlammerKopieren(')');
		 break;
      case '{' : KlammerKopieren('}');
		 break;
      case '#' : RestlZeileKopieren();
		 break;
      case '/' : KommentarBearbeiten();
		 break;
      case '_' : WortBearbeiten();
		 break;
      default  : if (isalpha(aktZeich))
		   WortBearbeiten();
		 else
		   ZeichenAusgeben(aktZeich);
     }
}

void Drucken()                              /*Dr 24.02.92 */
{
  zeilenZaehler = 0;
  seitenZaehler = 1;
  dateiSchreiben = TRUE;
  KopfZeilenAusgeben();

  nextZeich = fgetc(inFile);
  while (!feof(inFile))
    DateiBearbeiten();
  fputs(FormFeed, drucker);
}


int main(int argc, char* argv[])              /* 12.07.92 */
{
  int fehlerCode = 0;

  drucker = fopen(DruckerName, "w");

  if (drucker)
   {SetPrinter();
    if (argc > 1)
      {
       while (--argc > 0)
	 {strcpy(dateiName, *++argv);
	  inFile = fopen(dateiName, "rb");
	  if (inFile)
	    {TopZeilenErstellen();
	     Drucken();
	     fclose(inFile);
	    }
	  else
	    {printf("nicht zu oeffnen: %s\n",*argv[argc-1]);
	     fehlerCode = 10;;
	    }
	 }
      }
    else
      {printf("\nBitte Dateiname als Parameter!\n\n");
       fehlerCode = 11;
      }
    fclose(drucker);
   }
   else
     {printf("Drucker nicht ausgabebereit!\n\n");
      fehlerCode = 12;;
     }
  return(fehlerCode);
}
